diff -r 1e55e1aa8b7f sys/netinet/mptcp_var.h
--- /dev/null	Thu Jan 01 00:00:00 1970 +0000
+++ b/sys/netinet/mptcp_var.h	Fri Jul 11 13:32:06 2014 +1000
@@ -0,0 +1,478 @@
+/*-
+ * Copyright (c) 2012-2013
+ * 	Swinburne University of Technology, Melbourne, Australia.
+ * All rights reserved.
+ *
+ * This software was developed at the Centre for Advanced Internet
+ * Architectures, Swinburne University of Technology, by Nigel Williams and
+ * Lawrence Stewart, made possible in part by a gift from The Cisco University
+ * Research Program Fund, a corporate advised fund of Silicon Valley Community
+ * Foundation.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHORS AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHORS OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ */
+
+/*
+ * mptcp_var.h
+ *
+ *  Created on: 15/05/2012
+ *      Author: nwilliams
+ */
+
+#ifndef MPTCP_VAR_H_
+#define MPTCP_VAR_H_
+
+#define MAX_SUBFLOWS 8
+#define MAX_ADDRS 	8
+
+#define	BTOHEX_MSBLTOR	0x01
+#define	BTOHEX_MSBRTOL	0x02
+
+struct tcpopt;
+
+/*
+ * Globally accessible index of addresses that can be
+ * used for mp_enabled connections. set via a sysctl.
+ * mp_address_advertised is a bitmask that records whether
+ * an address has been advertised.
+ *
+ * Initialised in mptcp_subr.c
+ */
+extern int mp_address_count;
+extern struct sockaddr_storage mp_usable_addresses[MAX_ADDRS];
+
+/* Head of reassembly list for a subflow */
+struct sf_reass_queue_head {
+	struct tseg_qent *tqh_first;	/* first element */
+	struct tseg_qent **tqh_last;	/* addr of last next element */
+	struct tseg_qent *disordered;/* first out of order segment in subflow list */
+	STAILQ_ENTRY(sf_reass_queue_head) tqe_next_head;
+};
+
+struct mp_addr_v4 {
+	uint32_t token;
+	in_port_t in_port;
+	uint8_t pos_mask;
+	uint8_t	id;
+	uint8_t is_backup:1;
+	struct	in_addr in_addr;
+};
+
+struct mp_path_map {
+	struct mp_addr_v4 *local_address;
+	struct mp_addr_v4 *remote_address;
+};
+
+TAILQ_HEAD(sf_send_head, sfsendmap_qent);
+STAILQ_HEAD(sf_reass_queues_list_head, sf_reass_queue_head);
+
+/*
+ * Multi-path Session Control Block
+ * XXXNJW: Re-order for better alignment?
+ */
+struct mpcb {
+	struct	inpcb *master_inpcb;	/* back pointer to master internet pcb */
+	struct	tcpcb *master_tcpcb;	/* back pointer to master tcp cb */
+	struct	socket *master_socket;	/* pointer to socket of master subflow */
+
+	struct mtx mpcb_mutex;		/* mutex for the control block */
+
+	struct	callout mpt_rexmt;	/* data-level retransmit callout */
+	int mp_rxtcur;				/* Current data-level RTO in ticks */
+	uint8_t doing_rxmit; 			/* Is a ds-level rexmit required? */
+
+	int mp_added_address_count;	/* added (via add_addr) subflows */
+	int mp_conn_address_count; /* number of addresses available to session */
+	int subflow_cnt;			/* total number of subflows */
+	struct sockaddr_storage mp_added_addresses[MAX_ADDRS];
+
+	/*
+	 * list of reass list heads  for subflows
+	 * create list heads and place into queue, then use pointer from tcpcb.
+	 * Lock access to reass queue list, and individual subflow reass lists
+	 */
+	struct sf_reass_queues_list_head sf_reass_queues_list; /* head of subflow segment list-head list */
+	struct rwlock reass_queues_lock;	/* Lock for list of reassembly list heads, and the subflow segment lists */
+
+	struct sf_send_head sf_sendmap_q; /* subflow send buffer mappings queue */
+	struct dsmapq_head mp_ds_sndmaps;	/* send maps of subflows */
+	struct dsmapq_head mp_rxtmitmaps;	/* maps to be retransmitted */
+
+	SLIST_HEAD(tp_list_head, tcpcb) tp_list; /* list of subflow tcp control blocks */
+
+	struct  mp_addr_v4	loc_addrs[MAX_ADDRS]; /* local addresses available to this connection */
+	uint8_t	laddr_mask;				/* mask of address entries in loc_addrs */
+	struct  mp_addr_v4	rem_addrs[MAX_ADDRS]; /* remote addresses available to this connection */
+	uint8_t	raddr_mask;				/* mask of address entries in rem_addrs*/
+
+	int	mp_state;			/* state of mptcp connection */
+	int	mp_segqlen;			/* segment reassembly queue length */
+	int	mp_dupacks;			/* consecutive dup acks recd */
+
+	volatile int data_wait_count; /* Count of subflows currently stalled waiting for data */
+	uint8_t l_addr_index_cnt;		/* number of entries in local address table */
+	uint8_t r_addr_index_cnt;		/* number of entries in local address table */
+	uint8_t path_cnt;		/* number of entries in local address table */
+
+	uint16_t mp_flags;	// flags
+    uint16_t drexmit_count; /* count of data_level rexmits triggered*/
+
+	uint32_t local_token; 	/* local token for mptcp connection */
+	uint32_t remote_token;  /* token generated by remote host */
+	uint64_t local_key; 	/* 64-bit key sent by this host */
+	uint64_t remote_key; 	/* 64-bit key from remote host */
+
+	uint64_t ds_idsn;		/* data seq initial data seq number */
+	uint64_t ds_snd_una;	/* oldest unacknowledged seq, data space */
+	uint64_t ds_snd_max;	/* max send seq num, data space */
+
+	uint64_t ds_map_max;	/* Seq num of next byte to be mapped to a SF */
+	uint64_t ds_map_min;	/* Lowest seq no. currently in a map (may be below UNA) */
+	uint32_t ds_snd_wnd;	/* current send window (based on rcvd window adv) */
+
+	uint64_t ds_idsr;		/* Initial data sequence receive */
+	uint64_t ds_rcv_nxt;	/* next expected data seq number */
+	uint64_t ds_last_rcvd;	/* the last received ds seq number */
+	uint32_t ds_rcv_wnd;	/* Receive window to be advertised by sub-flows */
+	uint64_t ds_last_dack_sent; /* Last sent data-level ACK */
+
+	uint8_t	mp_status;		/* flags for connection status */
+	uint8_t	direct_map:1,	/* mapping directly to the default subflow */
+			csum_enabled:1,	/* using csum with data segments */
+			passive_open:1,	/* TEMP - are we passive opener */
+			in_def_drop:1;	/* TEMP - are we in deferred drop func */
+
+	uint64_t alpha;			/* alpha value for congestion control */
+	uint64_t total_cwnd;	/* total cwnd of all subflows */
+
+	/*
+	 * The "path manager" of sorts, just an array of addresses
+	 * that have been received via add_addr options.
+	 * The address ID is just the index into the array.
+	 * XXXNJW: This cannot be used for interop, as we cannot
+	 * guarantee a mapping between address IDs and the array indexes
+	 *
+	 * Initialised in mptcp_subr.c
+	 */
+	struct sockaddr_storage mp_path_manager[MAX_ADDRS];
+	uint32_t mp_advaddr_mask; /* Mask for ADD_ADDRs sent */
+	uint32_t mp_advjoin_mask; /* Mask for MP_JOINs sent*/
+
+	struct task	join_task;	/* For enqueuing aysnc joins in swi */
+	struct task	data_task;	/* For enqueuing aysnc subflow data wakeup */
+	struct task pcb_create_task; /* For enqueueing async sf inp creation */
+	struct task	rexmit_task;	/* For enqueuing data-level rexmits */
+};
+
+#define	MPS_CLOSED		0	/* closed */
+#define	MPS_LISTEN		1	/* listening for connection */
+#define	MPS_SYN_SENT		2	/* active, have sent syn */
+#define	MPS_SYN_RECEIVED	3	/* have sent and received syn */
+#define MPS_PRE_ESTABLISHED	4 /* < MPS_ESTABLISHED can't add new subflows */
+#define	MPS_ESTABLISHED		5	/* established */
+#define	MPS_M_FIN_WAIT_1	6
+#define	MPS_M_FIN_WAIT_2	7
+#define MPS_M_CLOSING		8
+#define MPS_M_CLOSE_WAIT	9
+#define MPS_M_LAST_ACK		10
+#define MPS_M_TIME_WAIT		11
+
+
+#define MPO_GOTSYNACK	0x0001
+#define MPO_DSN_MAP	0x0002
+#define	MPO_DATA_ACK	0x0004
+#define MPO_DSN_64	0x0008
+#define MPO_GOTJOINSYNACK	0x0010	/* received a SYN/ACK with MP_JOIN */
+#define MPO_SET_DATA_FIN	0x0020	/* Data-FIN on next DSS */
+#define MPO_SEND_ADD_ADDR	0x0040	/* ADD_ADDR to be send on next packet */
+#define MPO_GOTJOINSYN	0x0080
+
+/* Flags to pass between input/output at subflow-level */
+#define SFF_GOT_SYNACK		0x0001
+#define SFF_GOT_JOIN_SYN	0x0002
+#define SFF_GOT_JOIN_SYNACK	0x0004
+#define SFF_GOT_JOIN_ACK	0x0008
+#define	SFF_DATA_WAIT		0x0010
+#define	SFF_NEED_DACK		0x0020
+#define SFF_FORCE_WIN_UPDATE	0x0040
+#define SFF_SEND_WAIT		0x0080
+
+#define MP_TOKEN_OFFSET	0
+#define MP_IDSN_OFFSET	12
+
+/* offsets for mptcp option parsing */
+#define MP_DSS_FLAGS_OFFSET	3
+#define MP_REMOTE_KEY_OFFSET	4
+#define MP_DATA_ACK_OFFSET 	4
+#define MP_DATA_ACK64_OFFSET	4
+#define MP_DSN_OFFSET			4
+#define MP_SUB_SEQN_OFFSET	8
+#define MP_DATA_LEN_OFFSET	12
+#define MP_CSUM_OFFSET	14
+#define MP_RCV_TOKEN_OFFSET	4
+#define MP_SND_RND_OFFSET	8
+#define MP_SND_MAC_OFFSET	4
+#define MP_SND_RND_SYNACK_OFFSET	12
+#define MP_FAIL_KEY_OFFSET	4
+#define MP_ADD_ADDR_OFFSET	4
+#define MP_ADDID_OFFSET		3
+
+/* MPTCP options */
+#define MPOF_CAPABLE_SYN	0x0001
+#define MPOF_CAPABLE_SYNACK	0x0002
+#define MPOF_CAPABLE_ACK	0x0004
+#define MPOF_MP_CAPABLE	0x0008
+#define MPOF_DSS		0x0010
+#define MPOF_DSN_MAP	0x0020
+#define MPOF_DATA_ACK	0x0040
+#define MPOF_ADD_ADDR	0x0080
+#define MPOF_ADD_ADDR_V4	0x0100
+#define MPOF_MP_JOIN	0x0200
+#define MPOF_MP_RST		0x0400
+#define MPOF_REMOVE_ADDR	0x0800
+#define MPOF_MP_PRIO	0x1000
+#define MPOF_USE_CSUM	0x2000
+#define MPOF_DSN64		0x4000
+#define MPOF_ACK64		0x8000
+#define MPOF_NEED_ACK	0x00010000
+#define MPOF_JOIN_SYN	0x00020000
+#define	MPOF_JOIN_ACK	0x00040000
+#define	MPOF_JOIN_SYNACK	0x00080000
+#define MPOF_BACKUP_PATH	0x00100000
+#define	MPOF_DATA_FIN	0x00200000
+#define MPOF_ADD_ADDR_V6	0x00400000
+#define MPOF_MP_FAIL	0x00800000
+#define MPOF_FASTCLOSE	0x01000000
+#define	MPOF_MAXOPT		0x02000000
+
+/* Bit Mask for D-FIN flag */
+#define MP_SET_DATA_FIN	0x20
+
+/* MPTCP status flags */
+#define MP_INIT 0
+#define CSUM_ENABLED 1
+
+/* mbuf tag defines */
+#define PACKET_TAG_DSN 10
+#define PACKET_COOKIE_MPTCP 34216894
+#define DSN_LEN	8
+
+#define MAPF_IS_SENT	0x00000001 /* Sent all data from map */
+#define MAPF_IS_ACKED	0x00000002 /* All data in map is acknowledged */
+#define MAPF_IS_DUP		0x00000004 /* Duplicate map, already acked at ds-level */
+#define MAPF_IS_REXMIT	0x00000008 /* Is a rexmit of a previously sent map */
+
+#define SB_NUNMAPPED(sb, mp) ((sb)->sb_actual - ((mp)->ds_map_max - (mp)->ds_map_min))
+#define	TCPS_SUBFLOWCLOSING(s)	((s) == TCPS_CLOSE_WAIT)
+
+/*
+ * MP Options. Use struct to hold the first four bytes,
+ * and bit masks to parse out an flags.
+ */
+
+/* MP_CAPABLE option */
+struct mp_capable {
+	uint8_t kind;		/* option kind */
+	uint8_t length;		/* length of option */
+	uint8_t ver_sub;	/* MPTCP version */
+	uint8_t flags;	/* MPTCP subtype */
+
+#define	USE_SHA1	1	/* Bit 1 */
+#define	USE_CSUM	128	/* Bit 8 */
+};
+
+/* DSS option */
+struct mp_dss {
+	uint8_t kind;
+	uint8_t length;
+	uint8_t	subtype;
+	uint8_t dss_flags;
+
+#define ACK_PRESENT	0x0001
+#define ACK_64_PRESENT	0x0002
+#define MAP_PRESENT	0x0004
+#define DSN_64	0x0008
+#define FIN_PRESENT	0x0010
+};
+
+/* MP_JOIN option flags */
+struct mp_join {
+	uint8_t kind;
+	uint8_t length;
+	uint8_t	sub_flags;
+	uint8_t addr_id;
+
+/* masks for bits 16-31 of dss option */
+#define IS_BACKUP	0x01
+};
+
+/* MP_ADD option */
+struct mp_add {
+	uint8_t kind;
+	uint8_t length;
+	uint8_t	sub_ipver;
+	uint8_t addr_id;
+
+#define IS_IPV4	1
+};
+
+struct dsn_tag {
+        struct m_tag tag;
+        uint64_t 	dsn;
+};
+
+struct dss_psdhead {
+	uint64_t dsn;
+	uint32_t ssn;
+	u_short	len;
+	u_short	pad;
+};
+
+typedef struct mptcp_key {
+	uint32_t keylen;
+	uint8_t key[];
+}        mptcp_key_t;
+
+
+/*
+ * LOCK MACROS used for:
+ * sf_reass_queues_list: when user process does reassembly
+ * t_segq: when segments are inserted into the reassembly list
+ */
+#define	SF_REASS_LOCK_INIT(mp)	rw_init(&mp->reass_queues_lock, "reass queues lock")
+#define	SF_REASS_LOCK_DESTROY(mp)	rw_destroy(&mp->reass_queues_lock)
+#define	SF_REASS_WLOCK(mp)	rw_wlock(&mp->reass_queues_lock)
+#define	SF_REASS_WUNLOCK(mp)	rw_wunlock(&mp->reass_queues_lock)
+#define	SF_REASS_RLOCK(mp)	rw_rlock(&mp->reass_queues_lock)
+#define	SF_REASS_RUNLOCK(mp)	rw_runlock(&mp->reass_queues_lock)
+
+#define MPCB_LOCK_INIT(mp) 	mtx_init(&mp->mpcb_mutex, "mpcb", NULL, MTX_DEF | MTX_RECURSE);		// need to add MTX_RECURSE?
+#define MPCB_LOCK(mp)		mtx_lock(&mp->mpcb_mutex)
+#define MPCB_UNLOCK(mp)	mtx_unlock(&mp->mpcb_mutex)
+#define	MPCB_LOCK_ASSERT(mp)	mtx_assert(&mp->mpcb_mutex, MA_OWNED)
+
+
+
+
+/* 64-bit DSN comparisons */
+#define	DSEQ_LT(a,b)	((int64_t)((a)-(b)) < 0)
+#define	DSEQ_LEQ(a,b)	((int64_t)((a)-(b)) <= 0)
+#define	DSEQ_GT(a,b)	((int64_t)((a)-(b)) > 0)
+#define	DSEQ_GEQ(a,b)	((int64_t)((a)-(b)) >= 0)
+
+#define	DSEQ_MIN(a, b)	((SEQ_LT(a, b)) ? (a) : (b))
+#define	DSEQ_MAX(a, b)	((SEQ_GT(a, b)) ? (a) : (b))
+
+/* MP-related debug output */
+
+
+/*
+ * Keep these defines in sync with debug_class struct in mptcp_subr.c
+	{.class = "MPSESSION"},
+	{.class = "DSMAP"}
+*/
+#define MPSESSION 	0x00000001
+#define DSMAP 		0x00000002
+#define SBSTATUS 	0x00000004
+#define REASS		0x00000008
+
+void mp_debug(uint32_t log_class, int msg_verbosity, uint32_t flags, char * fmt, ...);
+
+void	btohex(char *buf, uint32_t buf_len, uint8_t *bytes, int32_t bytes_len, int32_t flags);
+int		mp_output(struct tcpcb *tp);
+void	mp_input(struct tcpcb *tp, struct sockbuf *sb, struct mbuf *m);
+void	ds_reass_init(struct mpcb *m);
+void	mp_order_segment_list(struct tcpcb *tp, struct sockbuf *sb);
+u_int64_t
+		mp_generate_local_key(void);
+uint32_t
+		mp_do_hashing(struct mpcb *mp);
+uint32_t
+		mp_do_sha_hash(uint8_t *digest, uint8_t *key, uint64_t key_length);
+uint32_t
+		mp_get_token(uint8_t *digest);
+uint64_t
+		mp_new_idsn(uint8_t *digest);
+u_short	mp_dss_cksum(struct dss_psdhead);
+uint32_t mp_get_hmac
+		(uint8_t *digest, uint64_t local_key, uint64_t remote_key, uint32_t local_rand, uint32_t remote_rand);
+void	mp_update_map(struct mpcb *mp);
+void	mp_add_local_addr(struct mpcb *mp, struct in_addr *inp_local_addr, in_port_t lport, uint8_t address_id);
+void	mp_add_remote_addr(struct mpcb *mp, struct in_addr *inp_remote_addr, in_port_t rport, uint8_t address_id);
+void	mp_remove_remote_addr(struct mpcb *mp, uint8_t address_id);
+void 	mp_process_local_key(struct mpcb *mp, uint64_t local_key);
+void 	mp_process_remote_key(struct mpcb *mp, uint64_t remote_key);
+
+/* Interface management */
+int     mp_is_if_up(struct sockaddr *l_addr);
+int     mp_is_addr_default(struct sockaddr_in *l_addr, struct mpcb *mp);
+void    mp_update_available_addresses(struct mpcb *mp);
+
+/* tcp_usrreq subflow functions */
+int		tcp_subflow_attach(struct socket *so, struct inpcb *inp, struct mpcb *mp);
+int		tcp_subflow_connect(struct tcpcb *tp, struct sockaddr *nam, struct thread *td);
+
+/* tcp_output related */
+struct ds_map*
+		mp_get_map(struct mpcb *mp, unsigned int sf_mss);
+void
+		mp_insert_map(struct mpcb *mp, struct ds_map *map);
+uint32_t
+		mp_get_recwin(struct mpcb *mp);
+void	mp_update_sndwin(struct mpcb *mp, uint16_t win);
+
+struct ds_map *
+		mp_find_dsmap(struct tcpcb *tp, tcp_seq	seqnum);
+
+/* tcp_input related */
+void	mp_data_ack(struct mpcb *mp, uint64_t data_ack_num);
+void	mp_drop_from_sendbuffer_locked(struct mpcb *mp, int acked, struct ds_map *map);
+void	mp_drop_from_sendbuffer(struct mpcb *mp, int acked, struct ds_map *map);
+void	mp_deferred_sbdrop(struct mpcb *mp);
+void 	mp_init_established(struct tcpcb *tp);
+void	mp_set_ds_map(struct mpcb *mp, uint64_t ds_num);
+
+/* Terminating subflows */
+int		mp_close_subflows(void);
+int		mp_close_subflow(struct tcpcb *);
+void    mp_drop_subflow_tp(struct mpcb *mp, struct tcpcb *tp);
+void	mp_subflow_is_disconnected(struct tcpcb *tp);
+void 	mp_update_subflow_windows(struct tcpcb *tp);
+void	mp_set_cantrcvmore(struct tcpcb *tp);
+
+/* Functions for task queue */
+void	mp_join_task_handler(void *context, int pending);
+void	mp_datascheduler_task_handler(void *context, int pending);
+void 	mp_sf_alloc_task_handler(void *context, int pending);
+void	mp_rexmit_task_handler(void *context, int pending);
+
+/* data_level rexmit */
+void    mp_trigger_rexmit(struct mpcb *mp);
+//void    mp_queue_data_rexmit_unlocked(struct mpcb *mp);
+void    mp_queue_data_rexmit_unlocked(struct tcpcb *tp);
+
+/* To call from debugger */
+void    mp_print_reass_lists(struct mpcb *mp);
+void    mp_print_sqns(struct mpcb *mp);
+void    mp_print_maps(struct mpcb *mp);
+
+#endif /* MPTCP_VAR_H_ */
diff -r 1e55e1aa8b7f sys/netinet/tcp.h
--- a/sys/netinet/tcp.h	Sun May 04 01:33:02 2014 +0000
+++ b/sys/netinet/tcp.h	Fri Jul 11 13:32:06 2014 +1000
@@ -97,6 +97,7 @@
 #define    TCPOLEN_TSTAMP_APPA		(TCPOLEN_TIMESTAMP+2) /* appendix A */
 #define	TCPOPT_SIGNATURE	19		/* Keyed MD5: RFC 2385 */
 #define	   TCPOLEN_SIGNATURE		18
+#define TCPOPT_MPTCP	30
 
 /* Miscellaneous constants */
 #define	MAX_SACK_BLKS	6	/* Max # SACK blocks stored at receiver side */
